# Copyright (C) 1999, 2000 Jay Beale
# Licensed under the GNU General Public License

package Bastille::ConfigureMiscPAM;

use Bastille::API;
@ENV="";
$ENV{PATH}="";
$ENV{CDPATH}=".";
$ENV{BASH_ENV}="";

# To DO:
#
# 1. Expand LimitRemoteRootLogins
#


#######################################################################
##    Misc. Pluggable Authentication Modules (PAM) Configuration     ##
#######################################################################

&ModifyLimitsconf;

# TO DO: Expand this for non-redhat systems
#&LimitRemoteRootLogins;

&LimitConsoleLogins;



sub ModifyLimitsconf {

    # Change /etc/security/limits.conf to prevent many types of DoS attacks.

    if ($GLOBAL_CONFIG{"ConfigureMiscPAM"}{"limitsconf"} eq "Y") {

       &ActionLog("# sub ModifyLimitsconf\n");

       my $file=$GLOBAL_FILE{"limits.conf"};

       &B_append_line ($file,"hard\s*core","# prevent core dumps\n*\thard\tcore\t0\n\n");
       &B_append_line ($file,"soft\s*nproc","#limit user processes per user to 150\n*\tsoft\tnproc\t100\n");
       &B_append_line ($file,"hard\s*nproc","*\thard\tnproc\t150\n\n");
       &B_append_line ($file,"hard\s*fsize","# limit size of any one of users' files to 40mb\n*\thard\tfsize\t40000\n\n");
   }

}

#sub LimitRemoteRootLogins {

   #&ActionLog("# sub LimitRemoteRootLogins\n");

# Limit root to logging in only from console, closing up brute force 
# remote attacks against root's password

### RedHat6.0 - based systems already limit this -- we mostly want to make
### sure that this hasn't changed.

# Further, note that we don't have to add the second admin account to 
# /etc/securetty, since securetty does a UID lookup on its listings and
# on the current account and compares...

#}

sub LimitConsoleLogins {

    # Limit console logins to a small set of prenamed accounts

    if ( ( $GLOBAL_CONFIG{"ConfigureMiscPAM"}{"consolelogin"} eq "Y") and ($GLOBAL_CONFIG{"ConfigureMiscPAM"}{"consolelogin_accounts"} )) {

	&ActionLog("# sub LimitConsoleLogins\n");

        # Optionally, limit console logins to root and the administrator.

	my $console_accts = $GLOBAL_CONFIG{"ConfigureMiscPAM"}{"consolelogin_accounts"};

	my $file=$GLOBAL_FILE{"pam_access.conf"};

	&B_append_line($file,"^\s*[^#].*:console\s*\$","-:ALL EXCEPT $console_accts:console\n");

   }
	    
}



1;

